CreatorProperty
Date: 2016-12-04

com.fasterxml.jackson.databind.deser

## Class CreatorProperty

- java.lang.Object
- - com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase
  - - com.fasterxml.jackson.databind.deser.SettableBeanProperty
    - - com.fasterxml.jackson.databind.deser.CreatorProperty

- All Implemented Interfaces:
    BeanProperty, Named, java.io.Serializable

      public class CreatorProperty
      extends SettableBeanProperty

  This concrete sub-class implements property that is passed via Creator (constructor or static factory method). It is not a full-featured implementation in that its set method should never be called -- instead, value must separately passed.

  Note on injectable values: unlike with other mutators, where deserializer and injecting are separate, here we treat the two as related things. This is necessary to add proper priority, as well as to simplify coordination.

  See Also:
    Serialized Form

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface com.fasterxml.jackson.databind.BeanProperty

      `BeanProperty.Std`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected AnnotatedParameter` | `_annotated` Placeholder that represents constructor parameter, when it is created from actual constructor.
    `protected int` | `_creatorIndex`
    `protected SettableBeanProperty` | `_fallbackSetter` In special cases, when implementing "updateValue", we can not use constructors or factory methods, but have to fall back on using a setter (or mutable field property).
    `protected java.lang.Object` | `_injectableValueId` Id of value to inject, if value injection should be used for this parameter (in addition to, or instead of, regular deserialization).

    - ### Fields inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

      `_contextAnnotations, _managedReferenceName, _objectIdInfo, _propertyIndex, _propName, _type, _valueDeserializer, _valueTypeDeserializer, _viewMatcher, _wrapperName, MISSING_VALUE_DESERIALIZER`

    - ### Fields inherited from class com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase

      `_metadata, _propertyFormat`

    - ### Fields inherited from interface com.fasterxml.jackson.databind.BeanProperty

      `EMPTY_FORMAT, EMPTY_INCLUDE`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `CreatorProperty(CreatorProperty src, JsonDeserializer<?> deser)`
    `protected` | `CreatorProperty(CreatorProperty src, PropertyName newName)`
    `` | `CreatorProperty(PropertyName name, JavaType type, PropertyName wrapperName, TypeDeserializer typeDeser, Annotations contextAnnotations, AnnotatedParameter param, int index, java.lang.Object injectableValueId, PropertyMetadata metadata)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `deserializeAndSet(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object instance)` Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism.
    `java.lang.Object` | `deserializeSetAndReturn(com.fasterxml.jackson.core.JsonParser p, DeserializationContext ctxt, java.lang.Object instance)` Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available.
    `java.lang.Object` | `findInjectableValue(DeserializationContext context, java.lang.Object beanInstance)` Method that can be called to locate value to be injected for this property, if it is configured for this.
    `void` | `fixAccess(DeserializationConfig config)` Method called to ensure that the mutator has proper access rights to be called, as per configuration.
    `<A extends java.lang.annotation.Annotation> A` | `getAnnotation(java.lang.Class<A> acls)` Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.
    `int` | `getCreatorIndex()` Method for accessing index of the creator property: for other types of properties will simply return -1.
    `java.lang.Object` | `getInjectableValueId()` Accessor for id of injectable value, if this bean property supports value injection.
    `AnnotatedMember` | `getMember()` Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
    `void` | `inject(DeserializationContext context, java.lang.Object beanInstance)` Method to find value to inject, and inject it to this property.
    `void` | `set(java.lang.Object instance, java.lang.Object value)` Method called to assign given value to this property, on specified Object.
    `java.lang.Object` | `setAndReturn(java.lang.Object instance, java.lang.Object value)` Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)
    `void` | `setFallbackSetter(SettableBeanProperty fallbackSetter)` NOTE: one exception to immutability, due to problems with CreatorProperty instances being shared between Bean, separate PropertyBasedCreator
    `java.lang.String` | `toString()`
    `CreatorProperty` | `withName(PropertyName newName)` Fluent factory method for constructing and returning a new instance with specified property name.
    `CreatorProperty` | `withValueDeserializer(JsonDeserializer<?> deser)` Fluent factory method for constructing and returning a new instance with specified value deserializer.

    - ### Methods inherited from class com.fasterxml.jackson.databind.deser.SettableBeanProperty

      `_throwAsIOE, _throwAsIOE, _throwAsIOE, _throwAsIOE, assignIndex, depositSchemaProperty, deserialize, getContextAnnotation, getDeclaringClass, getFullName, getManagedReferenceName, getName, getObjectIdInfo, getPropertyIndex, getType, getValueDeserializer, getValueTypeDeserializer, getWrapperName, hasValueDeserializer, hasValueTypeDeserializer, hasViews, setManagedReferenceName, setObjectIdInfo, setViews, visibleInView, withName, withSimpleName`

    - ### Methods inherited from class com.fasterxml.jackson.databind.introspect.ConcreteBeanPropertyBase

      `findFormatOverrides, findPropertyFormat, findPropertyInclusion, getMetadata, isRequired, isVirtual`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### _annotated

          protected final AnnotatedParameter _annotated

      Placeholder that represents constructor parameter, when it is created from actual constructor. May be null when a synthetic instance is created.

    - #### _injectableValueId

          protected final java.lang.Object _injectableValueId

      Id of value to inject, if value injection should be used for this parameter (in addition to, or instead of, regular deserialization).

    - #### _creatorIndex

          protected final int _creatorIndex

      Since:
        2.1

    - #### _fallbackSetter

          protected SettableBeanProperty _fallbackSetter

      In special cases, when implementing "updateValue", we can not use constructors or factory methods, but have to fall back on using a setter (or mutable field property). If so, this refers to that fallback accessor.

      Mutable only to allow setting after construction, but must be strictly set before any use.

      Since:
        2.3

  - ### Constructor Detail

    - #### CreatorProperty

          public CreatorProperty(PropertyName name,
                         JavaType type,
                         PropertyName wrapperName,
                         TypeDeserializer typeDeser,
                         Annotations contextAnnotations,
                         AnnotatedParameter param,
                         int index,
                         java.lang.Object injectableValueId,
                         PropertyMetadata metadata)

      Parameters:
        `name` - Name of the logical property
        `type` - Type of the property, used to find deserializer
        `typeDeser` - Type deserializer to use for handling polymorphic type information, if one is needed
        `contextAnnotations` - Contextual annotations (usually by class that declares creator [constructor, factory method] that includes this property)
        `param` - Representation of property, constructor or factory method parameter; used for accessing annotations of the property
        `index` - Index of this property within creator invocation
      Since:
        2.3

    - #### CreatorProperty

          protected CreatorProperty(CreatorProperty src,
                         PropertyName newName)

      Since:
        2.3

    - #### CreatorProperty

          protected CreatorProperty(CreatorProperty src,
                         JsonDeserializer<?> deser)

  - ### Method Detail

    - #### withName

          public CreatorProperty withName(PropertyName newName)

      Description copied from class: `SettableBeanProperty`
      Fluent factory method for constructing and returning a new instance with specified property name. Note that this method should NOT change configuration of this instance.
      Specified by:
        `withName` in class `SettableBeanProperty`
      Parameters:
        `newName` - Name to use for the new instance.
      Returns:
        Newly constructed instance, if property name differs from the one used for this instance; or 'this' if not.

    - #### withValueDeserializer

          public CreatorProperty withValueDeserializer(JsonDeserializer<?> deser)

      Description copied from class: `SettableBeanProperty`
      Fluent factory method for constructing and returning a new instance with specified value deserializer. Note that this method should NOT change configuration of this instance.
      Specified by:
        `withValueDeserializer` in class `SettableBeanProperty`
      Parameters:
        `deser` - Deserializer to assign to the new property instance
      Returns:
        Newly constructed instance, if value deserializer differs from the one used for this instance; or 'this' if not.

    - #### fixAccess

          public void fixAccess(DeserializationConfig config)

      Description copied from class: `SettableBeanProperty`
      Method called to ensure that the mutator has proper access rights to be called, as per configuration. Overridden by implementations that have mutators that require access, fields and setters.
      Overrides:
        `fixAccess` in class `SettableBeanProperty`

    - #### setFallbackSetter

          public void setFallbackSetter(SettableBeanProperty fallbackSetter)

      NOTE: one exception to immutability, due to problems with CreatorProperty instances being shared between Bean, separate PropertyBasedCreator
      Since:
        2.6

    - #### findInjectableValue

          public java.lang.Object findInjectableValue(DeserializationContext context,
                                             java.lang.Object beanInstance)

      Method that can be called to locate value to be injected for this property, if it is configured for this.

    - #### inject

          public void inject(DeserializationContext context,
                    java.lang.Object beanInstance)
                      throws java.io.IOException

      Method to find value to inject, and inject it to this property.
      Throws:
        `java.io.IOException`

    - #### getAnnotation

          public <A extends java.lang.annotation.Annotation> A getAnnotation(java.lang.Class<A> acls)

      Description copied from interface: `BeanProperty`
      Method for finding annotation associated with this property; meaning annotation associated with one of entities used to access property.

      Note that this method should only be called for custom annotations; access to standard Jackson annotations (or ones supported by alternate `AnnotationIntrospector`s) should be accessed through `AnnotationIntrospector`.

      Specified by:
        `getAnnotation` in interface `BeanProperty`
      Specified by:
        `getAnnotation` in class `SettableBeanProperty`

    - #### getMember

          public AnnotatedMember getMember()

      Description copied from interface: `BeanProperty`
      Method for accessing primary physical entity that represents the property; annotated field, method or constructor property.
      Specified by:
        `getMember` in interface `BeanProperty`
      Specified by:
        `getMember` in class `SettableBeanProperty`

    - #### getCreatorIndex

          public int getCreatorIndex()

      Description copied from class: `SettableBeanProperty`
      Method for accessing index of the creator property: for other types of properties will simply return -1.
      Overrides:
        `getCreatorIndex` in class `SettableBeanProperty`

    - #### deserializeAndSet

          public void deserializeAndSet(com.fasterxml.jackson.core.JsonParser p,
                               DeserializationContext ctxt,
                               java.lang.Object instance)
                                 throws java.io.IOException

      Description copied from class: `SettableBeanProperty`
      Method called to deserialize appropriate value, given parser (and context), and set it using appropriate mechanism. Pre-condition is that passed parser must point to the first token that should be consumed to produce the value (the only value for scalars, multiple for Objects and Arrays).
      Specified by:
        `deserializeAndSet` in class `SettableBeanProperty`
      Throws:
        `java.io.IOException`

    - #### deserializeSetAndReturn

          public java.lang.Object deserializeSetAndReturn(com.fasterxml.jackson.core.JsonParser p,
                                                 DeserializationContext ctxt,
                                                 java.lang.Object instance)
                                                   throws java.io.IOException

      Description copied from class: `SettableBeanProperty`
      Alternative to `SettableBeanProperty.deserializeAndSet(com.fasterxml.jackson.core.JsonParser, com.fasterxml.jackson.databind.DeserializationContext, java.lang.Object)` that returns either return value of setter method called (if one is), or null to indicate that no return value is available. Mostly used to support Builder style deserialization.
      Specified by:
        `deserializeSetAndReturn` in class `SettableBeanProperty`
      Throws:
        `java.io.IOException`

    - #### set

          public void set(java.lang.Object instance,
                 java.lang.Object value)
                   throws java.io.IOException

      Description copied from class: `SettableBeanProperty`
      Method called to assign given value to this property, on specified Object.

      Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

      Specified by:
        `set` in class `SettableBeanProperty`
      Throws:
        `java.io.IOException`

    - #### setAndReturn

          public java.lang.Object setAndReturn(java.lang.Object instance,
                                      java.lang.Object value)
                                        throws java.io.IOException

      Description copied from class: `SettableBeanProperty`
      Method called to assign given value to this property, on specified Object, and return whatever delegating accessor returned (if anything)

      Note: this is an optional operation, not supported by all implementations, creator-backed properties for example do not support this method.

      Specified by:
        `setAndReturn` in class `SettableBeanProperty`
      Throws:
        `java.io.IOException`

    - #### getInjectableValueId

          public java.lang.Object getInjectableValueId()

      Description copied from class: `SettableBeanProperty`
      Accessor for id of injectable value, if this bean property supports value injection.
      Overrides:
        `getInjectableValueId` in class `SettableBeanProperty`

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `SettableBeanProperty`